#!/bin/bash
#
# D-star last heard script.  Uses ON1ARF's ambestream program and a 
# premade ambe vocabulary see: 
# http://kb9mwr.blogspot.com/2011/11/library-of-ambe-files.html
# Can be called via DTMF using ircddb and it's spin-offs:
# http://kb9mwr.blogspot.com/2009/09/decoding-d-star-ambe-dtmf.html
#
# All outputs must be in lower case for matching to ambe word files.  Spaces
# are appended to callsigns for the same reason.
#
CALLNO=4
#
while [ $CALLNO -gt 0 ]
do
#############################################
# For debug
echo "position" $CALLNO
lynx --dump http://dstarusers.org/viewrepeater.php?system=K9EAM| grep -A5 "Time Heard" | cut -c19-47 | tail -$CALLNO | head -1
#############################################
# Begin - isolate call and date/time
CALL1=`lynx --dump http://dstarusers.org/viewrepeater.php?system=K9EAM| grep -A5 "Time Heard" | cut -c19-25 | tail -$CALLNO | head -1 | sed 's/./ &/g;s/^ //' | awk {'print tolower($_)'}`
DATE1=`lynx --dump http://dstarusers.org/viewrepeater.php?system=K9EAM|grep -A5 "Time Heard" | cut -c26-43 | tail -$CALLNO | head -1`
# Convert UTC date-time to local
NEWDATE=`date "+%m/%d/%y %l:%M:%S %Z" -d "$DATE1 -0000"`
# For debuging
#echo $NEWDATE
# Further isolation of variables
# Month
MO1=`echo $NEWDATE | cut -c1-2`
# Day
DA1=`echo $NEWDATE | cut -c4-5`
# Hour
HR1=`echo $NEWDATE | cut -c9-10`
# Min
MN1=`echo $NEWDATE | cut -c12-13`
##### Convert numeric values to speakable ones
if [ $MO1 = "01" ]; then MO="january"; fi
if [ $MO1 = "02" ]; then MO="february"; fi
if [ $MO1 = "03" ]; then MO="march"; fi
if [ $MO1 = "04" ]; then MO="april"; fi
if [ $MO1 = "05" ]; then MO="may"; fi
if [ $MO1 = "06" ]; then MO="june"; fi
if [ $MO1 = "07" ]; then MO="july"; fi
if [ $MO1 = "08" ]; then MO="august"; fi
if [ $MO1 = "09" ]; then MO="september"; fi
if [ $MO1 = "10" ]; then MO="october"; fi
if [ $MO1 = "11" ]; then MO="november"; fi
if [ $MO1 = "12" ]; then MO="december"; fi
#
if [ $DA1 = "01" ]; then DA="one"; fi
if [ $DA1 = "02" ]; then DA="two"; fi
if [ $DA1 = "03" ]; then DA="three"; fi
if [ $DA1 = "04" ]; then DA="four"; fi
if [ $DA1 = "05" ]; then DA="five"; fi
if [ $DA1 = "06" ]; then DA="six"; fi
if [ $DA1 = "07" ]; then DA="seven"; fi
if [ $DA1 = "08" ]; then DA="eight"; fi
if [ $DA1 = "09" ]; then DA="nine"; fi
if [ $DA1 = "10" ]; then DA="ten"; fi
if [ $DA1 = "11" ]; then DA="eleven"; fi
if [ $DA1 = "12" ]; then DA="twelve"; fi
if [ $DA1 = "13" ]; then DA="thirteen"; fi
if [ $DA1 = "14" ]; then DA="fourteen"; fi
if [ $DA1 = "15" ]; then DA="fifteen"; fi
if [ $DA1 = "16" ]; then DA="sixteen"; fi
if [ $DA1 = "17" ]; then DA="seventeen"; fi
if [ $DA1 = "18" ]; then DA="eighteen"; fi
if [ $DA1 = "19" ]; then DA="nineteen"; fi
if [ $DA1 = "20" ]; then DA="twenty"; fi
if [ $DA1 = "21" ]; then DA="twenty one"; fi
if [ $DA1 = "22" ]; then DA="twenty two"; fi
if [ $DA1 = "23" ]; then DA="twenty three"; fi
if [ $DA1 = "24" ]; then DA="twenty four"; fi
if [ $DA1 = "25" ]; then DA="twenty five"; fi
if [ $DA1 = "26" ]; then DA="twenty six"; fi
if [ $DA1 = "27" ]; then DA="twenty seven"; fi
if [ $DA1 = "28" ]; then DA="twenty eight"; fi
if [ $DA1 = "29" ]; then DA="twenty nine"; fi
if [ $DA1 = "30" ]; then DA="thirty"; fi
#
if [ $HR1 = "1" ]; then HR="one"; fi
if [ $HR1 = "2" ]; then HR="two"; fi
if [ $HR1 = "3" ]; then HR="three"; fi
if [ $HR1 = "4" ]; then HR="four"; fi
if [ $HR1 = "5" ]; then HR="five"; fi
if [ $HR1 = "6" ]; then HR="six"; fi
if [ $HR1 = "7" ]; then HR="seven"; fi
if [ $HR1 = "8" ]; then HR="eight"; fi
if [ $HR1 = "9" ]; then HR="nine"; fi
if [ $HR1 = "10" ]; then HR="ten"; fi
if [ $HR1 = "11" ]; then HR="eleven"; fi
if [ $HR1 = "12" ]; then HR="twelve"; fi
#
if [ $MN1 = "01" ]; then MN="o one"; fi
if [ $MN1 = "02" ]; then MN="o two"; fi
if [ $MN1 = "03" ]; then MN="o three"; fi
if [ $MN1 = "04" ]; then MN="o four"; fi
if [ $MN1 = "05" ]; then MN="o five"; fi
if [ $MN1 = "06" ]; then MN="o six"; fi
if [ $MN1 = "07" ]; then MN="o seven"; fi
if [ $MN1 = "08" ]; then MN="o eight"; fi
if [ $MN1 = "09" ]; then MN="o nine"; fi
if [ $MN1 = "10" ]; then MN="ten"; fi
if [ $MN1 = "11" ]; then MN="eleven"; fi
if [ $MN1 = "12" ]; then MN="twelve"; fi
if [ $MN1 = "13" ]; then MN="thirteen"; fi
if [ $MN1 = "14" ]; then MN="fourteen"; fi
if [ $MN1 = "15" ]; then MN="fifteen"; fi
if [ $MN1 = "16" ]; then MN="sixteen"; fi
if [ $MN1 = "17" ]; then MN="seventeen"; fi
if [ $MN1 = "18" ]; then MN="eighteen"; fi
if [ $MN1 = "19" ]; then MN="nineteen"; fi
if [ $MN1 = "20" ]; then MN="twenty"; fi
if [ $MN1 = "21" ]; then MN="twenty one"; fi
if [ $MN1 = "22" ]; then MN="twenty two"; fi
if [ $MN1 = "23" ]; then MN="twenty three"; fi
if [ $MN1 = "24" ]; then MN="twenty four"; fi
if [ $MN1 = "25" ]; then MN="twenty five"; fi
if [ $MN1 = "26" ]; then MN="twenty six"; fi
if [ $MN1 = "27" ]; then MN="twenty seven"; fi
if [ $MN1 = "28" ]; then MN="twenty eight"; fi
if [ $MN1 = "29" ]; then MN="twenty nine"; fi
if [ $MN1 = "30" ]; then MN="thirty"; fi
if [ $MN1 = "31" ]; then MN="thirty one"; fi
if [ $MN1 = "32" ]; then MN="thirty two"; fi
if [ $MN1 = "33" ]; then MN="thirty three"; fi
if [ $MN1 = "34" ]; then MN="thirty four"; fi
if [ $MN1 = "35" ]; then MN="thirty five"; fi
if [ $MN1 = "36" ]; then MN="thirty six"; fi
if [ $MN1 = "37" ]; then MN="thirty seven"; fi
if [ $MN1 = "38" ]; then MN="thirty eight"; fi
if [ $MN1 = "39" ]; then MN="thirty nine"; fi
if [ $MN1 = "40" ]; then MN="forty"; fi
if [ $MN1 = "41" ]; then MN="forty one"; fi
if [ $MN1 = "42" ]; then MN="forty two"; fi
if [ $MN1 = "43" ]; then MN="forty three"; fi
if [ $MN1 = "44" ]; then MN="forty four"; fi
if [ $MN1 = "45" ]; then MN="forty five"; fi
if [ $MN1 = "46" ]; then MN="forty six"; fi
if [ $MN1 = "47" ]; then MN="forty seven"; fi
if [ $MN1 = "48" ]; then MN="forty eight"; fi
if [ $MN1 = "49" ]; then MN="forty nine"; fi
if [ $MN1 = "50" ]; then MN="fifty"; fi
if [ $MN1 = "51" ]; then MN="fifty one"; fi
if [ $MN1 = "52" ]; then MN="fifty two"; fi
if [ $MN1 = "53" ]; then MN="fifty three"; fi
if [ $MN1 = "54" ]; then MN="fifty four"; fi
if [ $MN1 = "55" ]; then MN="fifty five"; fi
if [ $MN1 = "56" ]; then MN="fifty six"; fi
if [ $MN1 = "57" ]; then MN="fifty seven"; fi
if [ $MN1 = "58" ]; then MN="fifty eight"; fi
if [ $MN1 = "59" ]; then MN="fifty nine"; fi
#
#Screen output/debug
echo $CALL1 "last_heard" $MO $DA "at" $HR $MN
#
SENTENCE=`echo $CALL1 "last_heard" $MO $DA "at" $HR $MN`
# define and append path to pre-made words on the fly
# note all forward slashes must be escaped. Just follow the example
SPEAK=`echo $SENTENCE | sed 's/[^ ][^ ]*/\/root\/words\/ambe\/&.ambe/g'`
ambestream -t "TEST" -v -4 -my KB9MWR -d 127.0.0.1 -p 40000 K9EAM B $SPEAK
#########
# Move to/read off next entry
CALLNO=$(( $CALLNO - 1 ))
done
#
exit 0
