#!/bin/bash
#
# Weather conditions for d-star,
# The script grabs that current decoded (METAR style) local weather 
# observations.  We do some magic to make it more speech readable.
#
# We use ON1ARF's ambestream program and a premade ambe vocabulary see:
# http://kb9mwr.blogspot.com/2011/11/library-of-ambe-files.html
# Can be called via DTMF using ircddb and it's spin-offs:
# http://kb9mwr.blogspot.com/2009/09/decoding-d-star-ambe-dtmf.html
#
##########
# Clean-up 
##########
/bin/rm -f /tmp/metar.txt > /dev/null 2>&1
/bin/rm -f /tmp/conditions.* > /dev/null 2>&1
#
###############
# Get the METAR
###############
# edit this URL to point to your areas local observations
wget http://weather.noaa.gov/pub/data/observations/metar/decoded/KGRB.TXT -O /tmp/metar.txt > /dev/null 2>&1
#
####################
## Extract variables
####################
TEMP1=`grep "Temperature" /tmp/metar.txt | cut -c13-15`
SKY1=`grep "Sky conditions" /tmp/metar.txt`
SKY=`echo $SKY1 | cut -c17-33`
#
# This determines if there is no wind at all ie. Calm. If it is, it sets a 
# flag. Cleaned up on 6/16/07
#
CALM1=`grep "Wind" /tmp/metar.txt`
CALM2=`echo $CALM1 | cut -d " " -f2`
#
    if [ $CALM2 = "Calm:0" ];
	then CALMFLAG=1;
	else CALMFLAG=0;
    fi    
#
#
    if [ $CALMFLAG = 0 ];
	then WIND1=`grep "Wind" /tmp/metar.txt`; WDIR1=`echo $WIND1 | cut -d " " -f4`;
    fi
#
# Had to set WDIR1 to something even if there is no wind, otherwise 
# bash complains that there is no unary operator.
#
    if [ $CALMFLAG = 1 ];
	then WDIR1="0"
    fi

#
# Again we use the calm flag to test and make a decision. If the
# flag is 1, it sets a null speed value. This is just to keep the
# variable values filled with something in the script.
#
    if [ $CALMFLAG = 1 ];
        then WSPEED1=" ";
        else WSPEED1=`echo $WIND1 | cut -d " " -f8`;
    fi
#
# Replacement of directions with non-abbreviated words.
#
    if [ $CALMFLAG = 1 ]; then WDIR=" "; fi     
    if [ $WDIR1 = "SSE" ]; then WDIR="south south east"; fi
    if [ $WDIR1 = "ESE" ]; then WDIR="east south east"; fi
    if [ $WDIR1 = "SSW" ]; then WDIR="south south west"; fi
    if [ $WDIR1 = "WSW" ]; then WDIR="west south west"; fi
    if [ $WDIR1 = "NNE" ]; then WDIR="north north east"; fi
    if [ $WDIR1 = "ENE" ]; then WDIR="east north east"; fi
    if [ $WDIR1 = "NNW" ]; then WDIR="north north west"; fi
    if [ $WDIR1 = "WNW" ]; then WDIR="west north west"; fi
    if [ $WDIR1 = "NE" ]; then WDIR="north east"; fi
    if [ $WDIR1 = "NW" ]; then WDIR="north west"; fi
    if [ $WDIR1 = "SE" ]; then WDIR="south east"; fi
    if [ $WDIR1 = "SW" ]; then WDIR="south west"; fi
    if [ $WDIR1 = "N" ]; then WDIR="north"; fi
    if [ $WDIR1 = "S" ]; then WDIR="south"; fi
    if [ $WDIR1 = "E" ]; then WDIR="east"; fi
    if [ $WDIR1 = "W" ]; then WDIR="west"; fi
################
# Break out temp 
   if [ $TEMP1 = "-1" ]; then TEMP="negative one"; fi
   if [ $TEMP1 = "-2" ]; then TEMP="negative two"; fi
   if [ $TEMP1 = "-3" ]; then TEMP="negative three"; fi
   if [ $TEMP1 = "-4" ]; then TEMP="negative four"; fi
   if [ $TEMP1 = "-5" ]; then TEMP="negative five"; fi
   if [ $TEMP1 = "-6" ]; then TEMP="negative six"; fi
   if [ $TEMP1 = "-7" ]; then TEMP="negative seven"; fi
   if [ $TEMP1 = "-8" ]; then TEMP="negative eight"; fi
   if [ $TEMP1 = "-9" ]; then TEMP="negative nine"; fi 
   if [ $TEMP1 = "-10" ]; then TEMP="negative ten"; fi 
   if [ $TEMP1 = "-11" ]; then TEMP="negative eleven"; fi
   if [ $TEMP1 = "-12" ]; then TEMP="negative twelve"; fi
   if [ $TEMP1 = "-13" ]; then TEMP="negative thirteen"; fi
   if [ $TEMP1 = "-14" ]; then TEMP="negative fourteen"; fi
   if [ $TEMP1 = "-15" ]; then TEMP="negative fifteen"; fi
   if [ $TEMP1 = "-16" ]; then TEMP="negative sixteen"; fi
   if [ $TEMP1 = "-17" ]; then TEMP="negative seventeen"; fi
   if [ $TEMP1 = "-18" ]; then TEMP="negative eighteen"; fi
   if [ $TEMP1 = "-19" ]; then TEMP="negative nineteen"; fi
   if [ $TEMP1 = "-20" ]; then TEMP="negative twenty"; fi
   #
   if [ $TEMP1 = "0" ]; then TEMP="zero"; fi   
   if [ $TEMP1 = "1" ]; then TEMP="one"; fi
   if [ $TEMP1 = "2" ]; then TEMP="two"; fi
   if [ $TEMP1 = "3" ]; then TEMP="three"; fi
   if [ $TEMP1 = "4" ]; then TEMP="four"; fi
   if [ $TEMP1 = "5" ]; then TEMP="five"; fi
   if [ $TEMP1 = "6" ]; then TEMP="six"; fi
   if [ $TEMP1 = "7" ]; then TEMP="seven"; fi
   if [ $TEMP1 = "8" ]; then TEMP="eight"; fi
   if [ $TEMP1 = "9" ]; then TEMP="nine"; fi
   if [ $TEMP1 = "10" ]; then TEMP="ten"; fi
   if [ $TEMP1 = "11" ]; then TEMP="eleven"; fi
   if [ $TEMP1 = "12" ]; then TEMP="twelve"; fi
   if [ $TEMP1 = "13" ]; then TEMP="thirteen"; fi
   if [ $TEMP1 = "14" ]; then TEMP="fourteen"; fi
   if [ $TEMP1 = "15" ]; then TEMP="fifteen"; fi
   if [ $TEMP1 = "16" ]; then TEMP="sixteen"; fi
   if [ $TEMP1 = "17" ]; then TEMP="seventeen"; fi
   if [ $TEMP1 = "18" ]; then TEMP="eighteen"; fi
   if [ $TEMP1 = "19" ]; then TEMP="nineteen"; fi
   if [ $TEMP1 = "20" ]; then TEMP="twenty"; fi
   if [ $TEMP1 = "21" ]; then TEMP="twenty one"; fi
   if [ $TEMP1 = "22" ]; then TEMP="twenty two"; fi
   if [ $TEMP1 = "23" ]; then TEMP="twenty three"; fi
   if [ $TEMP1 = "24" ]; then TEMP="twenty four"; fi
   if [ $TEMP1 = "25" ]; then TEMP="twenty five"; fi
   if [ $TEMP1 = "26" ]; then TEMP="twenty six"; fi
   if [ $TEMP1 = "27" ]; then TEMP="twenty seven"; fi
   if [ $TEMP1 = "28" ]; then TEMP="twenty eight"; fi
   if [ $TEMP1 = "29" ]; then TEMP="twenty nine"; fi
   if [ $TEMP1 = "30" ]; then TEMP="thirty"; fi
   if [ $TEMP1 = "31" ]; then TEMP="thirty one"; fi
   if [ $TEMP1 = "32" ]; then TEMP="thirty two"; fi
   if [ $TEMP1 = "33" ]; then TEMP="thirty three"; fi
   if [ $TEMP1 = "34" ]; then TEMP="thirty four"; fi
   if [ $TEMP1 = "35" ]; then TEMP="thirty five"; fi
   if [ $TEMP1 = "36" ]; then TEMP="thirty six"; fi
   if [ $TEMP1 = "37" ]; then TEMP="thirty seven"; fi
   if [ $TEMP1 = "38" ]; then TEMP="thirty eight"; fi
   if [ $TEMP1 = "39" ]; then TEMP="thirty nine"; fi
   if [ $TEMP1 = "40" ]; then TEMP="forty"; fi
   if [ $TEMP1 = "41" ]; then TEMP="forty one"; fi
   if [ $TEMP1 = "42" ]; then TEMP="forty two"; fi
   if [ $TEMP1 = "43" ]; then TEMP="forty three"; fi
   if [ $TEMP1 = "44" ]; then TEMP="forty four"; fi
   if [ $TEMP1 = "45" ]; then TEMP="forty five"; fi
   if [ $TEMP1 = "46" ]; then TEMP="forty six"; fi
   if [ $TEMP1 = "47" ]; then TEMP="forty seven"; fi
   if [ $TEMP1 = "48" ]; then TEMP="forty eight"; fi
   if [ $TEMP1 = "49" ]; then TEMP="forty nine"; fi
   if [ $TEMP1 = "50" ]; then TEMP="fifty"; fi
   if [ $TEMP1 = "51" ]; then TEMP="fifty one"; fi
   if [ $TEMP1 = "52" ]; then TEMP="fifty two"; fi
   if [ $TEMP1 = "53" ]; then TEMP="fifty three"; fi
   if [ $TEMP1 = "54" ]; then TEMP="fifty four"; fi
   if [ $TEMP1 = "55" ]; then TEMP="fifty five"; fi
   if [ $TEMP1 = "56" ]; then TEMP="fifty six"; fi
   if [ $TEMP1 = "57" ]; then TEMP="fifty seven"; fi
   if [ $TEMP1 = "58" ]; then TEMP="fifty eight"; fi
   if [ $TEMP1 = "59" ]; then TEMP="fifty nine"; fi
   if [ $TEMP1 = "60" ]; then TEMP="sixty"; fi
   if [ $TEMP1 = "61" ]; then TEMP="sixty one"; fi
   if [ $TEMP1 = "62" ]; then TEMP="sixty two"; fi
   if [ $TEMP1 = "63" ]; then TEMP="sixty three"; fi
   if [ $TEMP1 = "64" ]; then TEMP="sixty four"; fi
   if [ $TEMP1 = "65" ]; then TEMP="sixty five"; fi
   if [ $TEMP1 = "66" ]; then TEMP="sixty six"; fi
   if [ $TEMP1 = "67" ]; then TEMP="sixty seven"; fi
   if [ $TEMP1 = "68" ]; then TEMP="sixty eight"; fi
   if [ $TEMP1 = "69" ]; then TEMP="sixty nine"; fi
   if [ $TEMP1 = "70" ]; then TEMP="seventy"; fi
   if [ $TEMP1 = "71" ]; then TEMP="seventy one"; fi
   if [ $TEMP1 = "72" ]; then TEMP="seventy two"; fi
   if [ $TEMP1 = "73" ]; then TEMP="seventy three"; fi
   if [ $TEMP1 = "74" ]; then TEMP="seventy four"; fi
   if [ $TEMP1 = "75" ]; then TEMP="seventy five"; fi
   if [ $TEMP1 = "76" ]; then TEMP="seventy six"; fi
   if [ $TEMP1 = "77" ]; then TEMP="seventy seven"; fi
   if [ $TEMP1 = "78" ]; then TEMP="seventy eight"; fi
   if [ $TEMP1 = "79" ]; then TEMP="seventy nine"; fi
   if [ $TEMP1 = "80" ]; then TEMP="eighty"; fi
   if [ $TEMP1 = "81" ]; then TEMP="eighty one"; fi
   if [ $TEMP1 = "82" ]; then TEMP="eighty two"; fi
   if [ $TEMP1 = "83" ]; then TEMP="eighty three"; fi
   if [ $TEMP1 = "84" ]; then TEMP="eighty four"; fi
   if [ $TEMP1 = "85" ]; then TEMP="eighty five"; fi
   if [ $TEMP1 = "86" ]; then TEMP="eighty six"; fi
   if [ $TEMP1 = "87" ]; then TEMP="eighty seven"; fi
   if [ $TEMP1 = "88" ]; then TEMP="eighty eight"; fi
   if [ $TEMP1 = "89" ]; then TEMP="eighty nine"; fi
   if [ $TEMP1 = "90" ]; then TEMP="ninety"; fi
   # hope you have air conditioning
   #
   if [ $WSPEED1 = "1" ]; then WSPEED="one"; fi
   if [ $WSPEED1 = "2" ]; then WSPEED="two"; fi
   if [ $WSPEED1 = "3" ]; then WSPEED="three"; fi
   if [ $WSPEED1 = "4" ]; then WSPEED="four"; fi
   if [ $WSPEED1 = "5" ]; then WSPEED="five"; fi
   if [ $WSPEED1 = "6" ]; then WSPEED="six"; fi
   if [ $WSPEED1 = "7" ]; then WSPEED="seven"; fi
   if [ $WSPEED1 = "8" ]; then WSPEED="eight"; fi
   if [ $WSPEED1 = "9" ]; then WSPEED="nine"; fi
   if [ $WSPEED1 = "10" ]; then WSPEED="ten"; fi
   if [ $WSPEED1 = "11" ]; then WSPEED="eleven"; fi
   if [ $WSPEED1 = "12" ]; then WSPEED="twelve"; fi
   if [ $WSPEED1 = "13" ]; then WSPEED="thirteen"; fi
   if [ $WSPEED1 = "14" ]; then WSPEED="fourteen"; fi
   if [ $WSPEED1 = "15" ]; then WSPEED="fifteen"; fi
   if [ $WSPEED1 = "16" ]; then WSPEED="sixteen"; fi
   if [ $WSPEED1 = "17" ]; then WSPEED="seventeen"; fi   
   if [ $WSPEED1 = "18" ]; then WSPEED="eightteen"; fi
   if [ $WSPEED1 = "19" ]; then WSPEED="nineteen"; fi
   if [ $WSPEED1 = "20" ]; then WSPEED="twenty"; fi
   if [ $WSPEED1 = "21" ]; then WSPEED="twenty one"; fi
   if [ $WSPEED1 = "22" ]; then WSPEED="twenty two"; fi
   if [ $WSPEED1 = "23" ]; then WSPEED="twenty three"; fi
   if [ $WSPEED1 = "24" ]; then WSPEED="twenty four"; fi
   if [ $WSPEED1 = "25" ]; then WSPEED="twenty five"; fi
   if [ $WSPEED1 = "26" ]; then WSPEED="twenty six"; fi
   if [ $WSPEED1 = "27" ]; then WSPEED="twenty seven"; fi
   if [ $WSPEED1 = "28" ]; then WSPEED="twenty eight"; fi
   if [ $WSPEED1 = "29" ]; then WSPEED="twenty nine"; fi
   if [ $WSPEED1 = "30" ]; then WSPEED="thirty"; fi
   if [ $WSPEED1 = "31" ]; then WSPEED="thirty one"; fi
   if [ $WSPEED1 = "32" ]; then WSPEED="thirty two"; fi
   if [ $WSPEED1 = "33" ]; then WSPEED="thirty three"; fi
   if [ $WSPEED1 = "34" ]; then WSPEED="thirty four"; fi
   if [ $WSPEED1 = "35" ]; then WSPEED="thirty five"; fi
   if [ $WSPEED1 = "36" ]; then WSPEED="thirty six"; fi
   if [ $WSPEED1 = "37" ]; then WSPEED="thirty seven"; fi
   if [ $WSPEED1 = "38" ]; then WSPEED="thirty eight"; fi
   if [ $WSPEED1 = "39" ]; then WSPEED="thirty nine"; fi
#### too windy, hope your tower is well guyed
# 
#################
# Generate Output
#################
# This section processes the Screen output for the terminal.
# originally put it in for debugging..
#
echo "the_current_temperature_is $TEMP degrees" >> /tmp/conditions.txt
echo "skies_are $SKY" >> /tmp/conditions.txt
#
    if [ $CALMFLAG = 1 ];
	then echo "the_wind_is calm" >> /tmp/conditions.txt;
	else echo "the_wind_is from_the $WDIR at $WSPEED miles_per_hour" >> /tmp/conditions.txt;
    fi
# 
# Now for visual output. This just dumps the conditions.txt
# file to the console or a terminal window. This file is also read by
# Cepstral. 
#
cat /tmp/conditions.txt
echo "------------------------------------"
SENTENCE=`cat /tmp/conditions.txt`
# 
# note all forward slashes must be escaped. Just follow the example 
# 
SPEAK=`echo $SENTENCE | sed 's/[^ ][^ ]*/\/root\/words\/ambe\/&.ambe/g'` 
# 
TEXT=`echo "$TEMP1 deg. Winds $WDIR1 @ $WSPEED1 mph"`
ambestream -t "$TEXT" -v -4 -my KB9MWR -d 127.0.0.1 -p 40000 K9EAM B $SPEAK  
#
exit 0
#
# Exit with no errors
#
